<?php

/**
 * Description of SearchYoutube
 *
 * @author ehaberman
 */
class SearchYoutube 
{
    public $returnXResults = 10;
    
    private $client = "";
    
    public function __construct($api_key) 
    {        
        error_reporting(E_ALL^ E_WARNING);  
        set_include_path( dirname(__FILE__) . "/src/"); 
        
        if (!is_dir( dirname(__FILE__) . '/src/tmp'))
        {
            mkdir ( dirname(__FILE__) . '/src/tmp', 0755);
            mkdir ( dirname(__FILE__) . '/src/tmp/Google_Client', 0755);
        }
        
        require_once dirname(__FILE__) . '/src/Google/Client.php';
        require_once dirname(__FILE__) . '/src/Google/Service/YouTube.php';
                        
        $this->client = new Google_Client();
        $this->client->setDeveloperKey($api_key);
    }
    
    /*
     * get videos from youtube
     * @params string keyword, string api key
     */
    public function getVideos($keyword, $max_results)
    {                        
        // Define an object that will be used to make all API requests.
        $youtube = new Google_Service_YouTube($this->client);
        $returnArray = array();
        
        try 
        {
          // Call the search.list method to retrieve results matching the specified
          // query term.
          $searchResponse = $youtube->search->listSearch('snippet', array(
            'q' => $keyword,
            'maxResults' => $max_results,
            'type' => 'video'
          ));
          
          // Add each result to the appropriate list, and then display the lists of
          // matching videos, channels, and playlists.
            foreach ($searchResponse['items'] as $searchResult) 
            {                              
                switch ($searchResult['id']['kind']) 
                {
                    case 'youtube#video':
                        $id = $searchResult['id']['videoId'];                                                
                        $video_embed = '<iframe width="420" height="315" src="//www.youtube.com/embed/'.$id.'" frameborder="0" allowfullscreen></iframe>';
                        $image = "<img src='" . $searchResult['snippet']['thumbnails']['medium']['url'] . "' />";
                        $body = $video_embed . "<br/>" .$searchResult['snippet']['description'];
                        $excerpt = $this->createExcerpt($searchResult['snippet']['description'], 50);
                        
                        $returnArray[] = array( 
                            'title' => $searchResult['snippet']['title'], 
                            'id' => $id, 
                            'body' => $body,
                            'excerpt' => $excerpt,
                            'thumbnail' => $searchResult['snippet']['thumbnails']['high']['url']
                            );                        
                        break;                    
                }
            }          
          
        } catch (Google_ServiceException $e) {
          //echo sprintf('<p>A service error occurred: <code>%s</code></p>',htmlspecialchars($e->getMessage()));
        } catch (Google_Exception $e) {
          //echo sprintf('<p>An client error occurred: <code>%s</code></p>',htmlspecialchars($e->getMessage()));
        }  
        
        return $returnArray;   
    }
    
    private function createExcerpt($body, $wordCount)
    {
        $body = strip_tags($body);
        return implode( 
            '', 
            array_slice( 
                preg_split(
                  '/([\s,\.;\?\!]+)/', 
                  $body, 
                  $wordCount*2+1, 
                  PREG_SPLIT_DELIM_CAPTURE
                ),
                0,
                $wordCount*2-1
            )
        );        
    }
    
}
