<?php
    /*
    Plugin Name: Tsunami Content
    Plugin URI: http://tsunamisites.com
    Description: Monetize your blog with fast content generation!
    Version: 1.7
    Author: TsunamiSites
    Author URI: none
    */
             
    add_action('init', 'bi_insert_posts');
    function bi_insert_posts($preview = false, $requestKeyword = false, $customType = false, $customTypeValue = "text", $requestCategory = 0)
    {
        $options = get_option('tsunami_options');
        $imagesOnly = ($options['bi_includeimagesonly'] == 1) ? true : false;
        $nextPubTime = strtotime($options['bi_nextPubDate']);         
        $publish_type = ($options['bi_publish_as'] == 1) ? "draft" : "publish";
        $custom_title_prefix = !empty($options['bi_custom_title_prefix']) ? $options['bi_custom_title_prefix'] : "";
        $posts_per_day = $options['bi_postCount'];
        $lazyContent = ($options['bi_lazy_content'] == 1) ? true : false;
        
        $keywords = $options['bi_keyword'];
        if ( !$requestKeyword )
        {
            $keywordData = get_keyword($keywords, false, $options['bi_type'], $options['bi_category'], $options['bi_negative_keyword']);
            $keyword = $keywordData['keyword'];
            $type = $keywordData['type'];
            $category = $keywordData['category'];
            $negative_keyword = $keywordData['negative_keyword'];
        }
        else
        {
            $keyword = $requestKeyword;
            $type = $customTypeValue; 
            $category = $requestCategory;
        }
                                                                                           
        if ( ( !empty($keyword) && $nextPubTime !== false && $nextPubTime > 0 )  ||  ( $preview == true && !empty($keyword) ) ) 
        {
                        
            $tumblr_options = get_option('tsunami_tumblr');                                
            $youtube_options = get_option('tsunami_youtube');            
            
            if ( !tsunami_ready($tumblr_options, $youtube_options, $type) )
            {
                return false;
            }            
                        
            $now = time();
            if ($now >= $nextPubTime || $preview == true) 
            {                                                                                       
                                
                // already published IDs
                $published_ids = unserialize(get_option('bi_ezine_published_ids'));
                
                if ($type == "text" || $type == "photo")
                {                    
                    // tumblr api class
                    require_once 'lib/SearchTumblr.php';
                    
                    // tumblr search class
                    $tumblr = new Application_Model_SearchTumblr($tumblr_options['bi_ckey'], $tumblr_options['bi_csecret'], $tumblr_options['bi_token'], $tumblr_options['bi_tokensecret']);
                    $tumblr->nsfw = ($options['bi_nsfw']) ? true : false;
                    $tumblr->blogWordCount = $options['bi_minimumWords'];
                    $tumblr->usedIds = $published_ids;
                    $tumblr->imagesOnly = $imagesOnly;                    
                    $tumblr->customTitlePrefix = $custom_title_prefix;
                    $tumblr->negativeKeyword = $negative_keyword;
                    $tumblr->lazyContent = $lazyContent;                    

                    // fetch content
                    $blogs = $tumblr->getTaggedPosts($keyword, $type, true, false); 
                                        
                    // parse blog data                
                    $returnArray = parseBlogs($blogs, $keyword, $preview, $publish_type, $category, $posts_per_day); 
                }
                else
                {                                        
                    require_once 'lib/SearchYoutube.php';
                    
                    // youtube search class
                    $youtube = new SearchYoutube($youtube_options['bi_ykey']);                    
                    
                    // fetch videos from youtube
                    $videos = $youtube->getVideos($keyword, 10);
                    
                    // parse video data                    
                    $returnArray = parseVideos($videos, $keyword, $preview, $publish_type, $category);                    
                }                                                                                               
                
                if (!$preview)
                {
                    // Update bi_nextPubDate                                        
                    $options['bi_nextPubDate'] = date("Y-m-d", time() + 60*60*24*1);                                                           
                    update_option('tsunami_options', $options); 
                    update_option('bi_lastKeyword', $keywordData['lastKeyword']);
                }
                else
                {                              
                    return $returnArray;
                }                   
            }
        }
    }
    
    // setup the admin menu options page
    add_action('admin_menu', 'tsunami_admin_page');
    function tsunami_admin_page()
    {
        require_once('lib/src/Google/Clients.php');
        add_options_page('Tsunami Settings', 'Tsunami Settings', 'manage_options', 'tsunami', 'tsunami_options_page');
    }
        
    add_action('admin_init', 'tsunami_settings_api_init');
    function tsunami_settings_api_init()
    {
        // settings
        register_setting('tsunami_options', 'tsunami_options', 'tsunami_options_validate');
        add_settings_section('tsunami_main', '', 'tsunami_options_callback', 'tsunami_settings_tab');
        
        add_settings_field('bi_nextPubDate', 'Next Publication Date', 'setter_nextpub', 'tsunami_settings_tab', 'tsunami_main');
        add_settings_field('bi_custom_title_prefix', 'Custom Title Prefix', 'setter_custom_prefix', 'tsunami_settings_tab', 'tsunami_main');
        add_settings_field('bi_keyword', 'Keywords', 'setter_keyword', 'tsunami_settings_tab', 'tsunami_main');
        add_settings_field('bi_negative_keyword', '', 'setter_negative_keyword', 'tsunami_settings_tab', 'tsunami_main');
        add_settings_field('bi_minimumWords', 'Minimum Words In Text Posts', 'setter_minimumwords', 'tsunami_settings_tab', 'tsunami_main');
        add_settings_field('bi_postCount', 'Number of Daily Posts (10 max)', 'setter_postcount', 'tsunami_settings_tab', 'tsunami_main');
        add_settings_field('bi_lazy_content', 'Find content when no match found?', 'setter_lazycontent', 'tsunami_settings_tab', 'tsunami_main');
        add_settings_field('bi_type', '', 'setter_type', 'tsunami_settings_tab', 'tsunami_main');
        add_settings_field('bi_category', '', 'setter_category', 'tsunami_settings_tab', 'tsunami_main');
        add_settings_field('bi_nsfw', 'Allow Adult Content', 'setter_nsfw', 'tsunami_settings_tab', 'tsunami_main');
        add_settings_field('bi_includeimagesonly', 'Posts with Images Only', 'setter_includeimagesonly', 'tsunami_settings_tab', 'tsunami_main');
        add_settings_field('bi_publish_as', 'Publish as Draft', 'setter_publishas', 'tsunami_settings_tab', 'tsunami_main');
        add_settings_field('bi_custom_title_prefix', 'Custom Title Prefix', 'setter_custom_prefix', 'tsunami_settings_tab', 'tsunami_main');

        // tumblr settings
        register_setting('tsunami_tumblr', 'tsunami_tumblr', 'tsunami_options_validate');
        add_settings_section('tumblr_main', 'Tumblr Settings', 'tsunami_options_callback', 'tsunami_tumblr_tab');
        
        add_settings_field('bi_ckey', 'Consumer Key', 'setter_ckey', 'tsunami_tumblr_tab', 'tumblr_main');
        add_settings_field('bi_csecret', 'Consumer Secret', 'setter_csecret', 'tsunami_tumblr_tab', 'tumblr_main');
        add_settings_field('bi_token', 'Token', 'setter_token', 'tsunami_tumblr_tab', 'tumblr_main');
        add_settings_field('bi_tokensecret', 'Token Secret', 'setter_tokensecret', 'tsunami_tumblr_tab', 'tumblr_main'); 
        
        // youtube settings
        register_setting('tsunami_youtube', 'tsunami_youtube', 'tsunami_options_validate');
        add_settings_section('youtube_main', 'Youtube Settings', 'tsunami_options_callback', 'tsunami_youtube_tab');
        
        add_settings_field('bi_youtube_api_key', 'API Key', 'setter_ykey', 'tsunami_youtube_tab', 'youtube_main');
        
        // social settings
        register_setting('tsunami_social', 'tsunami_social', 'tsunami_options_validate');
        add_settings_section('social_main', 'Social Media Settings', 'tsunami_options_callback', 'tsunami_social_tab');
        
        add_settings_field('bi_fb', 'Enable Facebook Share Button?', 'setter_fb', 'tsunami_social_tab', 'social_main');
        add_settings_field('bi_fb_app_id', 'Facebook App ID', 'setter_fb_app_id', 'tsunami_social_tab', 'social_main');
        add_settings_field('bi_twitter', 'Enable Twitter Share Button?', 'setter_twitter', 'tsunami_social_tab', 'social_main');
        add_settings_field('bi_twitter_username', 'Twitter Username', 'setter_twitter_username', 'tsunami_social_tab', 'social_main');
        add_settings_field('bi_twitter_excerpt', 'Twitter Share Sentence', 'setter_twitter_excerpt', 'tsunami_social_tab', 'social_main');        
        add_settings_field('bi_pinterest', 'Enable Pinterest Pin?', 'setter_pinterest', 'tsunami_social_tab', 'social_main');
        add_settings_field('bi_social_before_post', 'Social Buttons Before Posts?', 'setter_social_before_post', 'tsunami_social_tab', 'social_main');
        add_settings_field('bi_social_after_post', 'Social Buttons After Posts?', 'setter_social_after_post', 'tsunami_social_tab', 'social_main');
        
        
        // licensing
        register_setting('tsunami_license', 'tsunami_license', 'tsunami_options_validate');
        add_settings_section('tsunami_license_check', 'Tsunami License', 'tsunami_options_callback', 'tsunami_license_section');
        
        add_settings_field('bi_email', 'Tsunami Account Email', 'setter_email', 'tsunami_license_section', 'tsunami_license_check');
        add_settings_field('bi_license', 'License Key', 'setter_license', 'tsunami_license_section', 'tsunami_license_check');        
    }
    
    function tsunami_options_callback(  )
    {
        
    }
    
    function setter_custom_prefix()
    {
        $options = get_option('tsunami_options');
        echo "<input id='bi_custom_title_prefix' name='tsunami_options[bi_custom_title_prefix]' type='text' value='{$options['bi_custom_title_prefix']}' />";
    }
    
    function setter_pinterest()
    {
        $options = get_option('tsunami_social');
        echo "<input id='bi_pinterest' name='tsunami_social[bi_pinterest]' type='checkbox' value='1'" . checked( 1, $options['bi_pinterest'], false ) . "/>";      
    }
    
    function setter_social_before_post()
    {
        $options = get_option('tsunami_social');
        echo "<input id='bi_social_before_post' name='tsunami_social[bi_social_before_post]' type='checkbox' value='1'" . checked( 1, $options['bi_social_before_post'], false ) . "/>";      
    }
    
    function setter_social_after_post()
    {
        $options = get_option('tsunami_social');
        echo "<input id='bi_social_after_post' name='tsunami_social[bi_social_after_post]' type='checkbox' value='1'" . checked( 1, $options['bi_social_after_post'], false ) . "/>";      
    }
    
    function setter_twitter()
    {
        $options = get_option('tsunami_social');
         echo "<input id='bi_twitter' name='tsunami_social[bi_twitter]' type='checkbox' value='1'" . checked( 1, $options['bi_twitter'], false ) . "/>";      
    }
    
    function setter_twitter_username()
    {
        $options = get_option('tsunami_social');
        echo "<input id='bi_twitter_username' name='tsunami_social[bi_twitter_username]' type='text' value='{$options['bi_twitter_username']}' />";
    }
    
    function setter_twitter_excerpt()
    {
        $options = get_option('tsunami_social');
        echo "<input id='bi_twitter_excerpt' name='tsunami_social[bi_twitter_excerpt]' type='text' value='{$options['bi_twitter_excerpt']}' />";
    }
    
    function setter_fb()
    {
        $options = get_option('tsunami_social');
         echo "<input id='bi_fb' name='tsunami_social[bi_fb]' type='checkbox' value='1'" . checked( 1, $options['bi_fb'], false ) . "/>";      
    }
    
    function setter_fb_app_id()
    {
        $options = get_option('tsunami_social');
        echo "<input id='bi_fb_app_id' name='tsunami_social[bi_fb_app_id]' type='text' value='{$options['bi_fb_app_id']}' />";
    }
    
    function setter_license() 
    {
        $options = get_option('tsunami_license');
        echo "<input id='bi_license' name='tsunami_license[bi_license]' type='text' value='{$options['bi_license']}' />";
    }
    
    function setter_email() 
    {
        $options = get_option('tsunami_license');
        echo "<input id='bi_email' name='tsunami_license[bi_email]' type='text' value='{$options['bi_email']}' />";
    }
    
    function setter_negative_keyword()
    {
//        $options = get_option('tsunami_options');
//        echo "<input id='bi_negative_keyword' name='tsunami_options[bi_negative_keyword]' type='text' value='{$options['bi_negative_keyword']}' />";
    }
    
    function setter_publishas()
    {
        $options = get_option('tsunami_options');
        echo "<input id='bi_publish_as' name='tsunami_options[bi_publish_as]' type='checkbox' value='1'" . checked( 1, $options['bi_publish_as'], false ) . "/>";
    }
    
    function setter_nextpub() 
    {
        $today = date('Y-m-d');
        $tomorrow = date('Y-m-d', strtotime($today. ' + 1 days'));
        $options = get_option('tsunami_options');
        $next = empty($options['bi_nextPubDate']) ? $tomorrow : $options['bi_nextPubDate'];
        
        echo "<input id='bi_nextPubDate' name='tsunami_options[bi_nextPubDate]' type='text' value='$next' />";
    }
    function setter_keyword() 
    {        
        $options = get_option('tsunami_options');
        $count = count($options['bi_keyword']);                
        
        $features = tsunami_available_features();
        $types = $features['types'];
                        
        $categories = get_categories(array('hide_empty' => 0, 'orderby' => 'name' ));                
        $keywordData = get_keyword(($options['bi_keyword']), true, array(), array(), '');
        
        for ( $x = 0; $x < $count; $x++ )
        {
            $current_type = $options['bi_type'][$x];
            $current_category = $options['bi_category'][$x];
            
            $select = "<select name='tsunami_options[bi_type][$x]'>";            
            foreach($types as $type)
            {
                if ($type == $current_type)
                {
                    $select .= "<option value='$type' selected>$type</option>";
                }
                else
                {
                    $select .= "<option value='$type'>$type</option>";
                }                
            }
            $select .= "</select>";
            
            $categorySelect = "<select name='tsunami_options[bi_category][$x]'>";            
            foreach($categories as $category)
            {
                if ($current_category == $category->cat_ID)
                {
                    $categorySelect .= "<option value='$category->cat_ID' selected>$category->name</option>";
                }
                else
                {
                    $categorySelect .= "<option value='$category->cat_ID'>$category->name</option>";
                }                                                
            }
            $categorySelect .= "</select>";
            
            $nextKeyword = $keywordData['keyword'] == $options['bi_keyword'][$x] && $keywordData['lastKeyword'] == $x ? 'tsunami_next_keyword' : '';
            
            echo tsunami_keyword_html($x, $nextKeyword, $select, $categorySelect, $options);
            
        }    
        
        echo "<a class='addKeyword' id='$x' style='display:block;cursor:pointer;'><img src='" . plugins_url( 'images/plus-sign.png' , __FILE__ ) . "' style='height:32px;margin-top:8px;' /> Add Keyword</a> "; 
    }
    function setter_minimumwords() 
    {
        $options = get_option('tsunami_options');
        echo "<input id='bi_minimumWords' name='tsunami_options[bi_minimumWords]' type='text' value='{$options['bi_minimumWords']}' />";
    }
    function setter_postcount() 
    {
        $options = get_option('tsunami_options');
        if (empty($options['bi_postCount']))
        {
            $value = 10;
        }
        else
        {
            $value = $options['bi_postCount'];
        }
        echo "<input id='bi_postCount' name='tsunami_options[bi_postCount]' type='text' value='{$value}' />";
    }
    function setter_type($custom = false, $types = array('text', 'photo')) 
    {
        if ($custom)
        {                        
            $select = "<select id='bi_customType'>";

            foreach($types as $type)
            {            
                $select .= "<option value='$type'>$type</option>";            
            }
            $select .= "</select>";

            echo $select;
        }        
    }
    function setter_category($custom = false) 
    {
        if ($custom)
        {   
            $categories = get_categories(array('hide_empty' => 0, 'orderby' => 'name' ));  
            
            $categorySelect = "<select id='tsunami_category_select' name='tsunami_options[bi_category][REPLACE_ME]'>";            
            foreach($categories as $category)
            {                
                $categorySelect .= "<option value='$category->cat_ID'>$category->name</option>";                                                                
            }
            $categorySelect .= "</select>";
            
            echo $categorySelect;
        }        
    }
    function setter_nsfw() 
    {
        $options = get_option('tsunami_options');
        echo "<input id='bi_nsfw' name='tsunami_options[bi_nsfw]' type='checkbox' value='1'" . checked( 1, $options['bi_nsfw'], false ) . "/>";
    }
    function setter_includeimagesonly() 
    {
        $options = get_option('tsunami_options');
        echo "<input id='bi_includeimagesonly' name='tsunami_options[bi_includeimagesonly]' type='checkbox' value='1'" . checked( 1, $options['bi_includeimagesonly'], false ) . "/>";
    }
    function setter_lazycontent() 
    {
        $options = get_option('tsunami_options');
        echo "<input id='bi_lazy_content' name='tsunami_options[bi_lazy_content]' type='checkbox' value='1'" . checked( 1, $options['bi_lazy_content'], false ) . "/>";
    }
    function setter_ykey() 
    {
        $options = get_option('tsunami_youtube');        
        echo "<input id='bi_ykey' name='tsunami_youtube[bi_ykey]' type='text' value='{$options['bi_ykey']}' />";
    }
    function setter_ckey() 
    {
        $options = get_option('tsunami_tumblr');        
        echo "<input id='bi_ckey' name='tsunami_tumblr[bi_ckey]' type='text' value='{$options['bi_ckey']}' />";
    }
    function setter_csecret() 
    {
        $options = get_option('tsunami_tumblr');
        echo "<input id='bi_csecret' name='tsunami_tumblr[bi_csecret]' type='text' value='{$options['bi_csecret']}' />";
    }
    function setter_token() 
    {
        $options = get_option('tsunami_tumblr');
        echo "<input id='bi_token' name='tsunami_tumblr[bi_token]' type='text' value='{$options['bi_token']}' />";
    }
    function setter_tokensecret() 
    {
        $options = get_option('tsunami_tumblr');
        echo "<input id='bi_tokensecret' name='tsunami_tumblr[bi_tokensecret]' type='text' value='{$options['bi_tokensecret']}' />";
    }
    function setter_lastkeyword() 
    {
        $options = get_option('tsunami_options');
        echo "<input id='bi_lastKeyword' name='tsunami_options[bi_lastKeyword]' type='text' value='{$options['bi_lastKeyword']}' />";
    }
    
    // validate our options
    function tsunami_options_validate($input)
    {
        
        if (!empty($input['bi_keyword']))
        {            
            $keywordReturn = array();
            foreach ($input['bi_keyword'] as $d)
            {
                $keywordReturn[] = $d;
            }
            
            $input['bi_keyword'] = $keywordReturn;
        }
        
        if (!empty($input['bi_negative_keyword']))
        {            
            $keywordReturn = array();
            foreach ($input['bi_negative_keyword'] as $d)
            {
                $keywordReturn[] = $d;
            }
            
            $input['bi_negative_keyword'] = $keywordReturn;
        }
        
        if (!empty($input['bi_type']))
        {            
            $typeReturn = array();
            foreach ($input['bi_type'] as $d)
            {
                $typeReturn[] = $d;
            }
            
            $input['bi_type'] = $typeReturn;
        }
        
        if (!empty($input['bi_category']))
        {            
            $categoryReturn = array();
            foreach ($input['bi_category'] as $d)
            {
                $categoryReturn[] = $d;
            }
            
            $input['bi_category'] = $categoryReturn;
        }
        
        return $input;
    }
           
    // uninstall plugin
    register_activation_hook(__FILE__, 'install_blog_integrator');
    register_deactivation_hook( __FILE__, 'remove_blog_integrator' );
    function install_blog_integrator() {
        add_option('bi_ezine_published_ids', serialize(array()), '', 'yes');
        add_option('bi_license', '', '', 'yes');
        add_option('bi_lastKeyword', '0', '', 'yes');
    }
    function remove_blog_integrator() {
        delete_option('bi_ezine_published_ids');
        delete_option('bi_lastKeyword');
        delete_option('bi_license');
    }
    
    // updater, only run while admin panel displayed                
    add_action('admin_init', 'tsunami_auto_update');
    function tsunami_auto_update()
    {            
        require_once 'wp_autoupdate.php';
        $wptuts_plugin_current_version = '1.7';
        $wptuts_plugin_remote_path = 'http://tsunamisites.com/arbitrage/update.php';
        $wptuts_plugin_slug = plugin_basename(__FILE__);            
        new wp_auto_update ($wptuts_plugin_current_version, $wptuts_plugin_remote_path, $wptuts_plugin_slug);
    }
    
        
    function tsunami_options_page() 
    {
        
        $features = tsunami_available_features();        
        $license = $features['license'];
        
        if( isset( $_GET[ 'tab' ] ) ) 
        {
            $active_tab = $_GET[ 'tab' ];
        } 
        else
        {
            $active_tab = 'content';
        }
        ?>
                        
            <style>
                .tsunami_logo {background-image:url('<?php echo plugins_url( 'images/tsunami-sites-logo.png' , __FILE__ ); ?>'); background-repeat: no-repeat; background-position: 98% 98%;}
                .fetchContentLoading {background-image:url('<?php echo plugins_url( 'images/16.GIF' , __FILE__ ); ?>') !important; color:yellow !important;font-weight:bold;}                
            </style>
            
            <div class='tsunami_container tsunami_logo'>
                <div class='tsunami_top_bar'>&nbsp;</div>                 
                <h2 style='z-index:999;text-shadow:1px 1px 2px gray;color:white;font-size:34px;margin-left:10px;margin-top:18px;'>Tsunami Sites</h2>
                <div style='padding:10px;'>    
                    
        <?php if (empty($license)): ?>
                                        
                    <form method="POST" action="options.php" id="license_check">
                        
                        <?php settings_fields('tsunami_license'); ?>
                        <?php do_settings_sections('tsunami_license_section'); ?>
                        
                        <input type="submit" value="Check License" class='button-tsunami' id="check_license" />
                        
                    </form>
                </div>
            </div>
            <script type="text/javascript">
                jQuery(document).ready(function($) {
                    $.support.cors = true;
                    
                   $("#check_license").on('click', function(e){
                        e.preventDefault();

                        var license = $("#bi_license").val();
                        var email = $("#bi_email").val();                                                

                        if (license === "" || email === "") {
                            alert("You need to enter your license information");
                            return false;
                        }
                        $(this).addClass('fetchContentLoading');
                        $.post(ajaxurl, {license:license, email:email, action:"tsunami_check_license", domain:"<?php echo (empty($_SERVER['HTTP_HOST'])) ? $_SERVER['HTTP_HOST'] : $_SERVER['SERVER_NAME']; ?>"}, function(response){
                            if (response.success) {
                                location.reload();
                            } else {
                                alert(response.msg);
                            }

                        }, 'json');
                        $(this).removeClass('fetchContentLoading');
                    return false;               
                   });
                });
            </script>
                    
        <?php else: ?>
                                
                <h2 class="nav-tab-wrapper">
                    
                    <a href="options-general.php?page=tsunami&tab=content" class="nav-tab <?php echo $active_tab == 'content' ? 'nav-tab-active' : ''; ?>">Content Preview</a>
                    <a href="options-general.php?page=tsunami&tab=post" class="nav-tab <?php echo $active_tab == 'post' ? 'nav-tab-active' : ''; ?>">Auto Blogging</a>
                    <a href="options-general.php?page=tsunami&tab=social" class="nav-tab <?php echo $active_tab == 'social' ? 'nav-tab-active' : ''; ?>">Social Settings</a>
                    <a href="options-general.php?page=tsunami&tab=tumblr" class="nav-tab <?php echo $active_tab == 'tumblr' ? 'nav-tab-active' : ''; ?>">Setup</a>
                    <a href="options-general.php?page=tsunami&tab=drafts" class="nav-tab <?php echo $active_tab == 'drafts' ? 'nav-tab-active' : ''; ?>">Approve Drafts</a>
                    
                    <?php if ($features['syndicator']): ?>                        
                        <a href="options-general.php?page=tsunami&tab=syndicator" class="nav-tab <?php echo $active_tab == 'syndicator' ? 'nav-tab-active' : ''; ?>">Syndicator</a>
                    <?php endif; ?>
                    
                    <a href="options-general.php?page=tsunami&tab=license" class="nav-tab <?php echo $active_tab == 'license' ? 'nav-tab-active' : ''; ?>">License</a>
                    
                </h2>
            
            <?php if ($active_tab != "content"  && $active_tab != "drafts"): ?>                                
                        <?php
                        
                            if ($active_tab == "post")
                            {
                                ?>
                                <form method="post" action="options.php" id='theFormContent'>
                                    <?php
                                        settings_fields('tsunami_options');                            
                                        do_settings_sections('tsunami_settings_tab');
                                    ?>
                                    <input type="submit" value="Save Changes" id="license_check" class='button-tsunami' />                                    
                                </form>
                                <?php
                            }
                            else if ($active_tab == "social")
                            {
                                if (isset($_GET['action']))
                                {
                                    require_once 'lib/Facebook.php';
                                    
                                    $facebook = new TsunamiFacebook("", "");
                                    $facebook->authenticate("");
                                    
                                }
                                ?>
                                <form method="post" action="options.php" id='theFormContent'>
                                    <?php
                                        settings_fields('tsunami_social');                            
                                        do_settings_sections('tsunami_social_tab');
                                    ?>
                                    <input type="submit" value="Save Changes" id="license_check" class='button-tsunami' />
                                </form>                                
                                <?php
                            }
                            else if ($active_tab == "tumblr")
                            {
                                ?>
                                <form method="post" action="options.php" id='theFormContent'>
                                    <?php
                                        settings_fields('tsunami_tumblr');                            
                                        do_settings_sections('tsunami_tumblr_tab');
                                    ?>                                
                                    <input type="submit" value="Save Changes" id="license_check" class='button-tsunami' />
                                </form>
                                <div style='height:60px;display:block;'>&nbsp;</div>
                                <form method="post" action="options.php" id='theFormContent'>
                                    <?php
                                        settings_fields('tsunami_youtube');                            
                                        do_settings_sections('tsunami_youtube_tab');
                                    ?>
                                    <p style='margin-top:5px;'>IP Address: <?php echo $_SERVER['SERVER_ADDR']; ?></p>
                                    <input type="submit" value="Save Changes" id="license_check" class='button-tsunami' />
                                </form>
                                <?php 
                                
                            } 
                            else if ($active_tab == "license")
                            {
                                tsunami_license_ui();
                            }
                            else if ($active_tab == "syndicator")
                            {
                                require_once 'lib/Syndicator.php';
                                $syndicator = new Syndicator();
                                
                                $domain = (!empty($_SERVER['HTTP_HOST'])) ? $_SERVER['HTTP_HOST'] : $_SERVER['SERVER_NAME'];
                                                                
                                $links = $syndicator->getMyLinks($domain);
                                
                                if (!empty($links))
                                {
                                    ?>
                                <table style="width:90%;" class="tsunami_syndicator_links_table">
                                    
                                    
                                <?php
                                if (is_array($links['results']))
                                {
                                    ?> <tr><th align="left">Syndicated Article</th><th align="left">Last Syndicated Date</th><th></th></tr> <?php
                                    foreach ($links['results'] as $link):
                                        ?>
                                        <tr>
                                            <td><?php echo $link['title']; ?></td>
                                            <td><?php echo $link['last_used_date']; ?></td>
                                            <td><button class="tsunami_remove_syndication" id="<?php echo $link['link_syndication_id']; ?>">Remove</button></td>
                                        </tr>
                                        <?php
                                    endforeach;
                                }
                                else
                                {
                                    ?>
                                        <tr>
                                            <td colspan="20"><h2>You don't have any links syndicated yet!</h2>
                                                
                                                <b>Here is a tutorial video on how to setup your links:</b>
                                                <br/>
                                                <iframe src="//www.youtube.com/embed/lmNvOFb1PR0" width="480" height="360" frameborder="0" allowfullscreen="allowfullscreen"></iframe>
                                                <br/><br/><br/>
                                            </td>
                                        </tr>
                                    
                                    <?php
                                }
                                    ?>
                                </table>
                                <?php
                                    echo "<h2 style='margin-top:30px;position:absolute;bottom:0px;left:10px;color:red;'>".count($links['results']) . " / " . $links['max'] . " Ad Network slots used</h2>";
                                }
                                else
                                {
                                    ?> <h2 style='margin:20px 8px;'>You don't have any ad network links setup</h2> <?php
                                }
                                
                                
                            }
                            
                        ?>
                                                                                                          
            <?php elseif ($active_tab == "content"): ?>                    
                    <style>.tsunami_preview_input label {min-width:160px;display:inline-block;}</style>
                    <p style='margin-top:20px;margin-bottom:20px;'>
                        <b>Before you can begin using the tool, you need to setup the API!  </b>
                        <br/><br/>
                        Go to the <a href='options-general.php?page=tsunami&tab=tumblr'>Setup</a> tab, it's a fast and easy process!
                        <br/><br/>
                        Use this page to preview auto-blogger content, 
                        you can create posts directly from the previewed content by clicking the "Create Post" button.                                                                                                  
                    </p>
                    <p class="tsunami_preview_input">
                        <label for="keyword">Keyword</label>
                        <input type='text' id='keyword' placeholder='Enter Keyword' />
                    </p>
                    <p class="tsunami_preview_input">
                        <label for="bi_customType">Content Type</label>
                        <?php 
                            $features = tsunami_available_features();
                            setter_type(true, $features['types']);
                        ?>
                    </p>
                    <p class="tsunami_preview_input">
                        <label for="tsunami_category_select">Add to category</label>
                        <?php setter_category(true); ?>
                    </p>
                    <?php $version = phpversion(); ?>
                    <div style="position:absolute;top:150px;right:50px;">PHP Version: <?php echo ($version < 5.3) ? "<a href='http://tsunamisites.com/tutorial/' style='margin-left:10px;' target='_blank'><font style='color:red;font-size:18px;'>Old PHP detected - $version</font></a>" : "<font style='color:#0C84DA'>$version</font>"; ?></div>
                    <button id="fetchContent" class='button-tsunami' style='display:inline-block;margin-left:0px;'>Find Content Now</button>
            <?php elseif ($active_tab == "drafts"): ?>
                    <?php echo tsunami_draft_posts(); ?>                               
            <?php endif; ?>
                    
                </div>                
            </div>
            
            <div class='tsunami_container' id='tsunami_preview_wrapper' style='display:none;'>
                <div class='tsunami_top_bar'>&nbsp;</div>                 
                <h2 style='z-index:999;text-shadow:1px 1px 2px gray;color:white;font-size:34px;margin-left:10px;margin-top:18px;margin-bottom:50px;'>Results</h2>
                <div id='preview'></div>
            </div>
            <script type="text/javascript" >
                var tsunamiContent = '';
                var pager = 0;
                jQuery(document).ready(function($) {                                        
                    
                    // fetch previews of content
                    $("#fetchContent").on('click', function(e){
                        e.preventDefault();
                        var keyword = $("#keyword").val();
                        var type = $("#bi_customType").val();
                        var data = {
                            'action': 'tsunami_content_preview',
                            'keyword': keyword,
                            'type': type
                        };
                        showLoading();
                        $.post(ajaxurl, data, function(response) {
                            
                            if (!response.success) {
                                alert("No content found for that keyword!");
                                hideLoading();
                                return;
                            }
                            
                            hideLoading();
                            
                            $("#tsunami_preview_wrapper").slideDown(); 
                            $("#preview").html('');
                            
                            parseContent(response);
                            
                        }, 'json');                        
                    });  
                    $("#keyword").on('keypress', function(e){                        
                        if (e.keyCode === 13)
                        {
                            $("#fetchContent").trigger('click');
                        }
                    });
                    
                    // page content
                    $("#nextContent").on('click', function(e){
                        e.preventDefault();
                        if (tsunamiContent.length <= pager) {
                            alert("End of results");
                            return;
                        }
                        for (i = 0; i < tsunamiContent.length + pager; i++)
                        {
                           parseContent(tsunamiContent);
                        }
                                                
                        pager+10;
                    });
                    
                    function parseContent(response)
                    {
                        $.each(response.results, function(k,v) {  
                            
                            var thumbnail = (v.post_thumbnail === false || v.post_thumbnail === "false") ? "<b>No thumbnail found</b>" : "<b>Thumbnail: </b><br/><img src='" + v.post_thumbnail + "' />";
                                
                               $("#preview").append(
                                    "<div class='tsunami_preview_wrap'>" +
                                    "<h2 id='" + k + "_title' style='margin-left:20px'>" + v.post_title + "</h2>" +
                                    "<div id='" + k + "_body' class='tsunami_preview_body'>" + v.post_content + "</div>" +
                                    "<div id='" + k + "_excerpt_preview' class='tsunami_preview_body'><b>Excerpt: </b>" + v.post_excerpt + "</div>" +
                                    "<div id='" + k + "_excerpt' class='tsunami_preview_excerpt'>" + v.post_excerpt + "</div>" +
                                    "<div id='" + k + "_thumbnail_preview' class='tsunami_preview_body'>" + thumbnail + "</div>" +
                                    "<div id='" + k + "_thumbnail' class='tsunami_preview_excerpt'>" + v.post_thumbnail + "</div>" +
                                    "<button class='button-primary tsunami_create_post' id='" + k + "'>Create Post</button>" +
                                    "</div>"
                                );
                            
                        });   
                    }
                        
                    
                    // delete keyword
                    $(".tsunami_delete_option").on('click', function(e){
                        e.preventDefault;                        
                        $(this).parents('.tsunami_keyword_wrapper').remove();
                    });
                    
                    // add new keyword
                    $(".addKeyword").on('click', function(e){
                        e.preventDefault();
                        
                        
                        var number = parseInt($(this).attr('id'));   
                        var select = "<label>Type</label><select name='tsunami_options[bi_type][" + number + "]'>" +
                                <?php 
                                    $features = tsunami_available_features();
                                    $types = $features['types'];
                                    foreach ($types as $type): ?>
                                         "<option value='<?php echo $type; ?>'><?php echo $type; ?></option>" + 
                                <?php endforeach; ?>
                                "</select>";
                        
                        var category = "<label style='margin-left:15px;width:60px !important;min-width:60px !important;'>Category</label><?php setter_category(true); ?>";
                        category = category.replace('REPLACE_ME', number);
                        
                        $(this).before("<div class='tsunami_keyword_wrapper'>" + 
                                "<div class='tsunami_keyword_option'><label>Keyword</label><input type='text' name='tsunami_options[bi_keyword][" + number + "]' /></div>" +
                                "<div class='tsunami_keyword_option'><label>Negative Keyword</label><input type='text' name='tsunami_options[bi_negative_keyword][" + number + "]' /></div>" +
                                "<div class='tsunami_keyword_option'>" + select + ' ' + category + "</div></div>");
                        
                        $(this).attr('id', number+1);
                        
                        return false;
                    });
                    
                    
                    
                    // create a post from a preview
                    $("#preview").on('click', 'button.tsunami_create_post', function(){
                       
                        var id = $(this).attr('id');
                        var title = $("#" + id + "_title").html();
                        var body = $("#" + id + "_body").html();
                        var excerpt = $("#" + id + "_excerpt").html();
                        var category = $("#tsunami_category_select").val();
                        var keyword = $("#keyword").val();
                        var thumbnail = $("#" + id + "_thumbnail").html();

                        $(this).addClass('fetchContentLoading');
                       
                        $.post(ajaxurl, {action:'tsunami_create_post', title:title, body:body, category:category, keyword:keyword, excerpt:excerpt, thumbnail:thumbnail}, function(response){                            
                             if (response.success) {
                                 alert("Post created!");
                             } else {
                                 alert("Uh oh, Failed to the create post!  Please refresh the page and try again.");
                             }
                        }, 'json');
                        
                        $(this).removeClass('fetchContentLoading');
                        
                    });
                    
                    // remove syndicator link
                    $(".tsunami_remove_syndication").on('click', function(){
                       alert('clicked');
                       var id = $(this).attr('id');
                       
                       $.post(ajaxurl, {action:'tsunami_remove_syndication', id:id}, function(response){
                            if (response.success) {
                                alert("Removed from the ad network!");
                                location.reload();
                            } else {
                                alert("There was a problem removing the link from the ad network, please contact support@tsunamisites.com");
                            }
                        }, 'json');
                    });
                    
                    // approve a draft post
                    $(".tsunami-approve-draft").on('click', function(e){
                        e.preventDefault();
                        
                        var id = $(this).attr('id');
                        
                        $.post(ajaxurl, {action:'tsunami_approve_draft', id:id}, function(response){
                            if (response.success) {
                                alert("Post Published!");
                                location.reload();
                            }
                        }, 'json');
                        
                    });
                    
                    // delete a draft post
                    $(".tsunami-delete-draft").on('click', function(e){
                        e.preventDefault();
                        
                        var id = $(this).attr('id');
                        
                        $.post(ajaxurl, {action:'tsunami_delete_draft', id:id}, function(response){
                            if (response.success) {
                                alert("Post Deleted!");
                                location.reload();
                            }
                        }, 'json');
                    });
                    
                    function showLoading() {
                        $("#fetchContent").addClass('fetchContentLoading');                        
                    }                    
                    function hideLoading() {
                        $("#fetchContent").removeClass('fetchContentLoading');
                    }
                    
                });
                
                
            </script>
        <?php endif; ?>
                    
                
        <?php
    }
    
    add_action('wp_ajax_tsunami_check_license', 'tsunami_check_license');
    function tsunami_check_license()
    {
        $email = $_POST['email'];
        $license = $_POST['license'];
        $domain = $_POST['domain'];        

        if (empty($license) || empty($email) || empty($domain))
        {
            echo json_encode(array('success' => false));
            die();
        }
        $array = "sucess"; 
        
        if ($array['success'])
        {
            $license_options = get_option('tsunami_license');            
            $license_options['bi_license'] = $license;
            $license_options['bi_email'] = $email;
            update_option("tsunami_license", $license_options);
        }
        
        echo $results;

        die();
    }
    
    add_action('wp_ajax_tsunami_approve_draft', 'tsunami_approve_draft');
    function tsunami_approve_draft()
    {
        $id = $_POST['id'];
        
        $post = get_post($id);        
        $post->post_status = "publish";
        wp_update_post($post);
        
        echo json_encode(array('success' => true));
        
        die();
    }
    
    add_action('wp_ajax_tsunami_remove_syndication', 'tsunami_remove_syndication');
    function tsunami_remove_syndication()
    {
       $id = $_POST['id'];
       $domain = (!empty($_SERVER['HTTP_HOST'])) ? $_SERVER['HTTP_HOST'] : $_SERVER['SERVER_NAME'];
       
       require_once 'lib/Syndicator.php';
       
       $syndicator = new Syndicator();
       $success = $syndicator->deleteLink($id, $domain);
       
       echo json_encode(array('success' => $success));
       
       die();
    }
    
    add_action('wp_ajax_tsunami_delete_draft', 'tsunami_delete_draft');
    function tsunami_delete_draft()
    {
        $id = $_POST['id'];
        
        wp_delete_post($id);
        
        echo json_encode(array('success' => true));
        
        die();
    }
    
add_action('wp_ajax_tsunami_create_post', 'tsunami_create_post');
function tsunami_create_post()
{
    $title = $_POST['title'];
    $body = $_POST['body'];
    $keyword = $_POST['keyword'];
    $excerpt = strip_tags($_POST['excerpt']);
    $thumbnail = $_POST['thumbnail'];

    if (isset($_POST['category']))
    {
        $category = array($_POST['category']);
    }
    else
    {
        $category = array();
    }

    $post = tsunami_post_creator($title, $body, $keyword, $excerpt, $thumbnail, $category);
    
    if ($post)
    {
        echo json_encode(array('success' => true));        
    }
    else
    {
        echo json_encode(array('success' => false));
    }
    

    die();
}

function tsunami_post_creator($title, $body, $keyword, $excerpt, $thumbnail, $category)
{
    if (empty($body) || empty($title))
    {
        return false;
    }

    $options = get_option('tsunami_options');                                                  
    $publish_type = ($options['bi_publish_as'] == 1) ? "draft" : "publish";

    $newPost = array(
        'post_title' => $title,
        'post_content' => $body,
        'post_status' => $publish_type,
        'tags_input' => $keyword,
        'post_category' => $category,
        'post_excerpt' => $excerpt            
    );


    if ($id = wp_insert_post($newPost))
    {            
        if (!empty($thumbnail))
        {                
            tsunami_add_thumbnail($id, $thumbnail);
        }
        return true;
    }
    else
    {
        return false;
    }
}
    
add_action( 'wp_ajax_tsunami_content_preview', 'tsunami_content_preview_callback' );
function tsunami_content_preview_callback() 
{
    //global $wpdb; 
    $keyword = $_POST['keyword'];
    $type = $_POST['type'];

    $results = bi_insert_posts(true, $keyword, true, $type);

    if (empty($results))
    {
        echo json_encode(array('success' => false));
    }
    else
    {
        echo json_encode(array('success' => true, 'results' => $results));
    }        

    die(); 
}
    
// syndicate post ajax
add_action( 'wp_ajax_tsunami_syndicate_post', 'tsunami_syndicate_post_callback' );
function tsunami_syndicate_post_callback()
{
    require_once 'lib/Syndicator.php';
    
    $post = get_post($_POST['id']);
    $link = get_permalink($post->ID);
    $title = $post->post_title;
    $domain = (!empty($_SERVER['HTTP_HOST'])) ? $_SERVER['HTTP_HOST'] : $_SERVER['SERVER_NAME'];

    $syndicator = new Syndicator();
    $results = $syndicator->addLink($link, $title, $domain);
    
    echo json_encode($results);
    die();
}

// post to facebook ajax
add_action( 'wp_ajax_tsunami_social_post', 'tsunami_social_post' );
function tsunami_social_post()
{
    require_once __DIR__ . '/lib/Facebook.php';
    
    $post = get_post($_POST['id']);
    $link = get_permalink($post->ID);
    $title = $post->post_title;
    $redirect_uri = $_POST['redirect_uri'];
    $domain = (!empty($_SERVER['HTTP_HOST'])) ? $_SERVER['HTTP_HOST'] : $_SERVER['SERVER_NAME']; 
    
    
    $facebook = new TsunamiFacebook();
    $facebook->app_id = "1449332712008825";
    $facebook->secret = "e05fb14027d9ea866891ea672fedaa7d";
    $result = $facebook->post($redirect_uri);
    if ($result['success'])
    {
        
        $results = array('success' => true);
    }
    else
    {
        $results = array('success' => false, 'redirect' => $result['redirect']);
    }
    
    
    echo json_encode($results);
    die(); 
}
    
// create related content links at the bottom of the post
function tsunami_previous_posts($preview)
{        
    $returnHtml = "<h3 style='margin-top:20px;'>From Around the Web</h3>";
    
    $posts = get_posts(array('offset'=> 1, 'posts_per_page' => 4, 'post_type' => 'post'));    
    $features = tsunami_available_features();

    if (empty($posts))
    {            
        return false;
    }

    if ($features['syndicator'])
    {
        require_once 'lib/Syndicator.php';
        $syndicator = new Syndicator();
    }
    
    if ($features['syndicator']) 
    {                          
        $sharedLink = $syndicator->getLink(1);  
        
        if (!empty($sharedLink['results']['link']))
        {
            $title = empty($sharedLink['results']['title']) ? $sharedLink['results']['link'] : $sharedLink['results']['title'];
            $returnHtml .= "<div><a href='" . $sharedLink['results']['link'] . "'>".$title."</a></div>";                     
        }        
    }   

    foreach ($posts as $post)
    {                        
        $returnHtml .= "<div><a href='" . get_page_link($post->ID) . "'>$post->post_title</a></div>";                 
    }   

    $returnHtml .= "<div class='tsunami_syndication_bottom_spacer'>&nbsp;</div>";

    return $returnHtml;
}
    
add_action('edit_form_after_title', 'tsunami_editor');
function tsunami_editor()
{
    global $post;
    $features = tsunami_available_features();
    ?>
        <style>
            .fetchContentLoading {background-image:url('<?php echo plugins_url( 'images/16.GIF' , __FILE__ ); ?>') !important; color:white !important;}
        </style>
        <script type='text/javascript'>
            var tsunamiContent = '';
            var pager = 1;
            jQuery(document).ready(function($){

                $("#fetchContent").on('click', function(e){
                    e.preventDefault();
                    tsunamiContent = '';
                    var keyword = $("#keyword").val();
                    var data = {
                        'action': 'tsunami_content_preview',
                        'keyword': keyword
                    };

                    showLoading();
                    $.post(ajaxurl, data, function(response) {

                        if (response.length === 0) {
                            alert("No articles found for that keyword!");
                            hideLoading();
                            return;
                        }
                        $("#nextContent").show();
                        tsunamiContent = response;

                        hideLoading();                           
                        $("#title-prompt-text").html('');
                        $.each(response, function(k,v) {
                            if (k === 0) {
                                $("#title").val(v.post_title);
                                tinymce.activeEditor.setContent(v.post_content);                                    
                            }                                
                        });                                                          
                    }, 'json');
                });   

                $("#nextContent").on('click', function(e){
                    e.preventDefault();
                    if (tsunamiContent.length <= pager) {
                        alert("End of results");
                        return;
                    }
                    $("#title").val(tsunamiContent[pager].post_title);
                    tinymce.activeEditor.setContent(tsunamiContent[pager].post_content); 
                    pager++;
                });
                function showLoading() {
                    $("#fetchContent").addClass('fetchContentLoading');                        
                }                    
                function hideLoading() {
                    $("#fetchContent").removeClass('fetchContentLoading');
                }

                $("#tsunamiSyndication").on('click', function(){
                    var id = $(this).attr('data-id');

                    var data = {
                         'action': 'tsunami_syndicate_post',
                         'id': id
                     };

                    $(this).addClass('fetchContentLoading');
                    $.post(ajaxurl, data, function(response) {
                        $('#tsunamiSyndication').removeClass('fetchContentLoading');
                        if (response.success){
                            alert('Post Syndicated');                            
                        } else {
                            alert('There is a problem with the syndication network, \n\n please contact support@tsunamisites.com and we\'ll fix this ASAP!');
                        }
                    }, 'json');
                    
                });
                
                $("#tsunamiSocialPoster").on('click', function(){
                    var id = $(this).attr('data-id');

                    var data = {
                         'action': 'tsunami_social_post',
                         'id': id, 
                         'redirect_uri': '<?php echo $_SERVER["REQUEST_URI"]; ?>',
                         <?php if (isset($_GET['code'])): ?> 'code': '<?php echo $_GET['code']; ?>', <?php endif; ?>
                         <?php if (isset($_GET['state'])): ?> 'state': '<?php echo $_GET['state']; ?>' <?php endif; ?>
                     };

                    $(this).addClass('fetchContentLoading');
                    $.post(ajaxurl, data, function(response) {
                        $('#tsunamiSocialPoster').removeClass('fetchContentLoading');
                        if (response.success){
                            alert('Posted to Facebook!');                            
                        } else {
                            location.href=response.redirect;
                            //alert('There is a problem with the Facebook network, \n\n please contact support@tsunamisites.com if the problem persists');
                        }
                    }, 'json');
                });
            });                
        </script>
<!--            <input type='text' id='keyword' placeholder='Enter Keyword' style='margin: 4px 0px 12px;padding:4px;' />
        <a id='fetchContent' style='margin: 4px 0px 12px;' class='button button-primary button-large'>Tsunami Content</a>
        <a id='nextContent' style='margin: 4px 0px 12px;display:none;' class='button button-primary button-large'>Next Content</a> -->
        <?php if ($features['syndicator']): ?>            
            <a id='tsunamiSyndication' data-id="<?php echo $post->ID; ?>" style='margin: 4px 0px 12px;' class='button button-primary button-large'>Tsunami Syndication</a>
        <?php endif; ?>
            
        <?php if ($features['social_poster']): ?>                     
<!--            <a href="<?php echo $_SERVER['REQUEST_URI'].'&tsunamifbpost=1'; ?>" id='11tsunamiSocialPoster' data-id="<?php echo $post->ID; ?>" style='margin: 4px 0px 12px;' class='button button-primary button-large'>Tsunami Facebook Post</a>-->
        <?php endif; ?>
    <?php
}


function httpPost($url, $params)
{
    $postData = '';
    
    foreach($params as $k => $v)
    {
       $postData .= $k . '='.$v.'&';
    }
    rtrim($postData, '&');

    $ch = curl_init(); 

    curl_setopt($ch, CURLOPT_URL,$url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER,true);
    curl_setopt($ch, CURLOPT_HEADER, false);
    curl_setopt($ch, CURLOPT_POST, count($postData));
    curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);   

    $output = curl_exec($ch);

    curl_close($ch);
    return $output;
 
}

// check for an already existing post with this title
function post_title_exists($title_str) 
{
    global $wpdb;
    return $wpdb->get_row("SELECT * FROM wp_posts WHERE post_title = '" . $title_str . "'", 'ARRAY_A');
}

function get_keyword($keywords, $preview = false, $types, $categories, $negative_keywords)
{
    $lastKeyword = get_option('bi_lastKeyword');
    $keywordCount = count($keywords);
    
    if ($keywordCount >= 1)
    {
        if ($lastKeyword == 0 && $keywordCount == 1)
        {
            $keyword = $keywords[0];
            $lastKeyword = 0;
            $type = $types[0];
            $category = array($categories[0]);
            $negative_keyword = $negative_keywords[0];
        }
        else
        {
            if (($lastKeyword + 1) == $keywordCount)
            {
                $keyword = $keywords[0];
                $lastKeyword = 0;
                $type = $types[0];
                $category = array($categories[0]);
                $negative_keyword = $negative_keywords[0];
            }
            else
            {
                $keyword = $keywords[$lastKeyword + 1];
                $type = $types[$lastKeyword + 1];
                $category = array($categories[$lastKeyword + 1]);
                $lastKeyword = $lastKeyword + 1;
                $negative_keyword = $negative_keywords[$lastKeyword + 1];
            }
        }
    }        
        
    return array('keyword' => $keyword, 'lastKeyword' => $lastKeyword, 'type' => $type, 'category' => $category, 'negative_keyword' => $negative_keyword);
}

/*
 * handle the tumblr results
 * @params array blogs, string keyword, string type, object tumblr class, bool preview, string publish or draft, array category of post
 */
function parseBlogs($blogs, $keyword, $preview, $publish_type, $category = array(0), $posts_per_day)
{
    $returnArray = array();
    $previousPosts = tsunami_previous_posts($preview);
    
    if (!$preview)
    {
        $published_ids = unserialize(get_option('bi_ezine_published_ids'));
    }
        
    $previousPostsHtml = "";
    if ($previousPosts != false) 
    {
        $previousPostsHtml = $previousPosts;
    }                   
    
    $x = 0;
    foreach ($blogs as $blog)
    {  
        if (!$preview && $x > $posts_per_day) { continue; }
        $newPost = array(
            'post_title' => $blog['title'],
            'post_content' => $blog['body'] . $previousPostsHtml,
            'post_status' => $publish_type,
            'tags_input' => $keyword,
            'post_category' => $category,
            'post_excerpt' => $blog['excerpt']
        );

        if (!$preview)
        {            
            if ($id = wp_insert_post($newPost))
            {                
                if (!empty($blog['thumbnail']))
                {
                    tsunami_add_thumbnail($id, $blog['thumbnail']);
                }
            }

            // Record id:
            $published_ids[] = $blog['id'];                    
        }
        else
        {            
            $newPost['post_thumbnail'] = $blog['thumbnail'];
            $returnArray[] = $newPost;
        }        
        $x++;
    }    
    
    if (!$preview)
    {
        update_option('bi_ezine_published_ids', serialize($published_ids));              
    }
    
    return $returnArray;
}


// add jquery to the plugin
add_action( 'wp_enqueue_scripts', 'tsunami_scripts' );
function tsunami_scripts() 
{    
    wp_enqueue_script(
        'tsunami-social-script',
        plugins_url( 'js/social.js' , __FILE__ ),
        array( 'jquery' )
    );
    
    wp_enqueue_script( 'pinterest', '//assets.pinterest.com/js/pinit.js', array(), false, true);
    
    $options = get_option('tsunami_social');
    $app_id = $options['bi_fb_app_id'];
    $params = array('app_id' => $app_id);
            
    wp_localize_script( 'tsunami-social-script', 'tsunamiParams', $params );
}

add_shortcode('tsunami_post_url', 'tsunami_post_url_shortcode');
function tsunami_post_url_shortcode($atts)
{
    return get_permalink();    
}

add_shortcode('tsunami_facebook_app_id', 'tsunami_facebook_app_id_shortcode');
function tsunami_facebook_app_id_shortcode()
{
    $social_options = get_option('tsunami_social');
    
    return $social_options['bi_fb_app_id'];
}

add_shortcode('tsunami_twitter_username', 'tsunami_twitter_username_shortcode');
function tsunami_twitter_username_shortcode($atts)
{
    $options = get_option('tsunami_social');
    return $options['bi_twitter_username'];
}

add_shortcode('tsunami_twitter_text', 'tsunami_twitter_text_shortcode');
function tsunami_twitter_text_shortcode($atts)
{
    $options = get_option('tsunami_social');
    return $options['bi_twitter_excerpt'];
}


function socialHtml($socialOptions)
{   
    
    $socialHtml = "";
    
    if ($socialOptions['bi_fb'] == 1 && !empty($socialOptions['bi_fb_app_id']))
    {                
        $socialHtml .= "<div class='tsunami_facebook_share_button' data-share-url='[tsunami_post_url]'><a>Share On Facebook</a></div>";        
    }        
       
    if ($socialOptions['bi_twitter'] == 1)
    {        
        $socialHtml .= "<div class='tsunami_twitter_share_button'><a href='https://twitter.com/share?url=[tsunami_post_url]&text=[tsunami_twitter_text]&via=[tsunami_twitter_username]' class='tsunami_twitter_button'>Share on Twitter</a></div>";        
    }        
    
    if ($socialOptions['bi_pinterest'] == 1)
    {
        $socialHtml .= '<div class="tsunami_social_button tsunami_pinterest"><a href="//www.pinterest.com/pin/create/button/?url=[tsunami_post_url]&description=Next%20stop%3A%20Pinterest" data-pin-do="buttonPin" data-pin-config="above"><img src="//assets.pinterest.com/images/pidgets/pinit_fg_en_rect_gray_20.png" /></a></div>';
    }
    
    if (!empty($socialHtml))
    {
        $socialHtml = "<div class='tsunami_social_div'>" . $socialHtml . "<br style='clear:both;' /></div>";
    }
            
    return $socialHtml;
    
}



add_action('wp_enqueue_scripts', 'tsunami_style_sheets');
function tsunami_style_sheets()
{
    wp_enqueue_style( 'tsunami-style-sheet', plugins_url( 'css/tsunami.css' , __FILE__ ) );
}

// get draft posts for approval
function tsunami_draft_posts()
{
    $posts = get_posts(array('post_status' => 'draft', 'posts_per_page' => 30, 'order'=> 'ASC', 'orderby' => 'title'));        
    if (empty($posts)) { echo "<h2>There aren't any draft posts!</h2>"; die(); }
    ?>
        <form id="" action="<?php echo admin_url('admin-ajax.php'); ?>" method="post" class="form" >
        <table class='tsunami_draft_wrap'>
            <tr><th></th><th>Title</th><th>Category</th><th>Preview</th></tr>
            
    <?php    
    foreach ($posts as $post)
    {
        $category = get_the_category($post->ID);
        ?>
            <tr>
                
                <td class='tsunami_draft_wrap_select'><button class="button-primary tsunami-approve-draft" id='<?php echo $post->ID; ?>'>Approve</button></td>
                <td class='tsunami_draft_wrap_title'><?php echo $post->post_title; ?></td>
                <td class='tsunami_draft_wrap_title'><?php echo (empty($category)) ? "Uncategorized" : $category[0]->name; ?></td>
                <td class='tsunami_draft_wrap_preview'><a href='/?p=<?php echo $post->ID; ?>&preview=true' target='_blank'>Preview</a></td>
                <td class='tsunami_draft_wrap_select'><button class="delete tsunami-delete-draft" id='<?php echo $post->ID; ?>'>Delete</button></td>
            </tr>
           
        <?php        
    }
    ?>
        </table>             
        </form>
    <?php
}
add_action( 'admin_head', 'admin_css' );
function admin_css()
{
    echo '<link rel="stylesheet" type="text/css" href="' . plugins_url( 'css/tsunami.css' , __FILE__ ) . '">';
}   

// include the widget
include('tsunami_news_widget.php');

// parse videos
function parseVideos($videos, $keyword, $preview, $publish_type, $category)
{
    
    $previousPosts = tsunami_previous_posts($preview);
    $returnArray = array();
    
    if (!$preview)
    {
        $published_ids = unserialize(get_option('bi_ezine_published_ids'));
    }
        
    $previousPostsHtml = "";
    if ($previousPosts != false) 
    {
        $previousPostsHtml = $previousPosts;
    }        
        
    
    foreach ($videos as $video)
    {                        
        $newPost = array(
            'post_title' => $video['title'],
            'post_content' => $video['body'] . $previousPostsHtml,
            'post_status' => $publish_type,
            'tags_input' => $keyword,
            'post_category' => $category,
            'post_excerpt' => $video['excerpt']
       );

        if (!$preview)
        {            
            if ($id = wp_insert_post($newPost))
            {                
                if (!empty($video['thumbnail']))
                {                    
                    tsunami_add_thumbnail($id, $video['thumbnail']);
                }
            }

            // Record id:
            $published_ids[] = $video['id'];                    
        }
        else
        {
            $newPost['post_thumbnail'] = $video['thumbnail'];
            $returnArray[] = $newPost;
        }                                  
    }    
    
    if (!$preview)
    {
        update_option('bi_ezine_published_ids', serialize($published_ids));              
    }
    
    return $returnArray;
}

function tsunami_ready($tumblr_options, $youtube_options, $type)
{
    switch($type)
    {
        case "text":
            if (empty($tumblr_options['bi_ckey']) 
                    || empty($tumblr_options['bi_csecret']) 
                    || empty($tumblr_options['bi_token']) 
                    || empty($tumblr_options['bi_tokensecret']))
            {
                return false;
            }
            break;
        case "photo":
            if (empty($tumblr_options['bi_ckey']) 
                    || empty($tumblr_options['bi_csecret']) 
                    || empty($tumblr_options['bi_token']) 
                    || empty($tumblr_options['bi_tokensecret']))
            {
                return false;
            }
            break;
        case "video":
            if (empty($youtube_options['bi_ykey']))
            {
                return false;
            }
            break;
    }
    
    return true;
}

// create a thumbnail from an image in the post / video
function tsunami_add_thumbnail($id, $src)
{   
        
    require_once(ABSPATH . 'wp-admin/includes/media.php');
    require_once(ABSPATH . 'wp-admin/includes/file.php');
    require_once(ABSPATH . 'wp-admin/includes/image.php');
        
    media_sideload_image($src, $id);   
    $attachments = get_children(array('post_parent' => $id, 'numberposts' => 1, 'post_mime_type' => 'image', 'post_type' => 'attachment'));
        
    if ( $attachments ) 
    {
        foreach ( $attachments as $attachment ) 
        {
            set_post_thumbnail($id, $attachment->ID);
        }
    }               
    
}

function tsunami_available_features()
{
    $license_options = get_option('tsunami_license');            
    $license = $license_options['bi_license'];
    $features = array();
    
    $features['types'] = array('text', 'video', 'photo'); 
    
    if (preg_match('/^SOC|^ULT/', $license))
    {
        $features['social_poster'] = true;
    }
    else
    {
        $features['social_poster'] = false;
    } 
    
    if (preg_match('/^SYN|^ULT/', $license))
    {
        $features['syndicator'] = true;
    }
    else
    {
        $features['syndicator'] = false;
    } 
    
    $features['license'] = $license;
    
    return $features;
}

// setup the widget
function register_tsunami_news_widget()
{    
    register_widget('tsunami_news_widget');
}
add_action('widgets_init', 'register_tsunami_news_widget');

// show the license setup on the tab, or if the user hasn't authenticated yet
function tsunami_license_ui()
{
    
    ?>   
    <form method="POST" action="options.php" id="license_check">

        <?php settings_fields('tsunami_license'); ?>
        <?php do_settings_sections('tsunami_license_section'); ?>

        <input type="submit" value="Check License" class='button-tsunami' id="check_license" />

    </form>
      
    <?php
}

add_action( 'the_content', 'tsunami_add_social_html' );
function tsunami_add_social_html( $content )
{
    if (is_single())
    {
        //$fb_like_button = "<fb:like href='". get_site_url() . "' width='450' height='80' />";
        $options = get_option('tsunami_social');    
        $socialHtml = socialHtml($options);
        $before = "";
        $after = "";                
        
        if ( $options['bi_social_after_post'] == 1 )
        {
            $before = $socialHtml;
        }
        
        if ( $options['bi_social_before_post'] == 1 )
        {
            $after = $socialHtml;
        }        

        return $before . $content . $after;
    }
    return $content;
}

add_action( 'wp_head', 'tsunami_head_injector' );
function tsunami_head_injector()
{
    global $post;
        
    $thumb_id = get_post_thumbnail_id($post->ID);
    $thumb_url = wp_get_attachment_image_src($thumb_id, 'thumbnail-size', true);   
       
    if ( is_single() && !empty($thumb_url[0]))
    {
        global $post;
        
        $thumb_id = get_post_thumbnail_id($post->ID);
        $thumb_url = wp_get_attachment_image_src($thumb_id, 'thumbnail-size', true); 
    
        $social_options = get_option('tsunami_social');    
        $app_id = $social_options['bi_fb_app_id'];
        
        ?>
            
            <meta property="og:image" content="<?php echo $thumb_url[0]; ?>" />
            <meta property="og:description" content="<?php the_excerpt(); ?>" />
            <meta property="og:type" content="article"/>
        <?php 
    }
    ?>
            
        <meta property="og:url" content="<?php echo get_permalink(); ?>"/>
        <meta property="og:title" content="<?php echo get_the_title(); ?>" />        
        <meta property="fb:app_id" content="<?php echo $app_id; ?>" />
        
    <?php
}

// remove the p tags from excerpt
remove_filter('the_excerpt', 'wpautop');

// generate the tsunami auto-blogger keyword options
function tsunami_keyword_html($x, $nextKeyword, $select, $categorySelect, $options)
{
    
    ?>
        <div class='tsunami_keyword_wrapper <?php echo $nextKeyword; ?>'>
    
            <div class="tsunami_keyword_option">
                <label for="bi_keyword_<?php echo $x; ?>">Keyword</label>            
                <input id='bi_keyword_<?php echo $x; ?>' name='tsunami_options[bi_keyword][<?php echo $x; ?>]' type='text' value='<?php echo $options['bi_keyword'][$x]; ?>' />            
            </div>   
            
            <div class="tsunami_keyword_option">
                <label for="bi_negative_keyword_<?php echo $x; ?>">Negative Keyword</label>            
                <input id='bi_negative_keyword_<?php echo $x; ?>' placeholder='Comma separated list' name='tsunami_options[bi_negative_keyword][<?php echo $x; ?>]' type='text' value='<?php echo $options['bi_negative_keyword'][$x]; ?>' />            
            </div>  
            
            <div class="tsunami_keyword_option">
                <label>Type</label>
                <?php echo $select; ?>
                <label style='margin-left:15px;width:60px !important;min-width:60px !important;'>Category</label>
                <?php echo $categorySelect; ?>
            </div>                                  
            
            <div class="tsunami_delete_option_div">
                <a class='tsunami_delete_option button-primary'>Delete</a>
            </div>
            
        </div>            
    <?php
    
}